MEMORY {
	flash : ORIGIN = 0x00000000, LENGTH = 256K
	ram : ORIGIN = 0x1FFF8000, LENGTH = 64K
}

SECTIONS {
	.text : {
		KEEP(*(.vectors))
		. = 0x400;
		KEEP(*(.flashconfig*))
		*(.startup*)
		*(.text*)
		*(.rodata*)
	} >flash

	.data : { *(.data*) } >ram AT>flash

	.bss : { *(.bss*) } >ram

	_sdata = ADDR(.data);
	_edata = ADDR(.data) + SIZEOF(.data);
	_ldata = LOADADDR(.data);

	_sbss = ADDR(.bss);
	_ebss = ADDR(.bss) + SIZEOF(.bss);

	_estack = ORIGIN(ram) + LENGTH(ram);
}
